import GLOOP.*;
public class Box{
    private GLQuader quader; 
    private Spielfeld feld;
    private double vX,vZ;
    private double breite, tiefe;

    public Box(double pBreite, double pTiefe, Spielfeld pFeld){
        breite = pBreite;
        tiefe = pTiefe;
        quader = new GLQuader(0,15,0,breite,30,tiefe);
        quader.setzeMaterial(GLMaterial.RUBIN); 
        vX = 0;
        vZ = 0;
        feld = pFeld;        
    }

    public void setzeBewegung(double pvX, double pvZ){
        vX = pvX;
        vZ = pvZ;
    }

    public void bewege(){
        if (quader.gibX()<-feld.gibBreite()/2 || quader.gibX()>feld.gibBreite()/2){
            vX = -vX;
        }
        if (quader.gibZ()<-feld.gibTiefe()/2 || quader.gibZ()>feld.gibTiefe()/2){
            vZ = -vZ;
        }
        quader.verschiebe(vX,0,vZ);
    }

    public double gibBreite(){
        return 50;
    }

    public double gibTiefe(){
        return 50;
    }

    public double gibX(){
        return quader.gibX();
    }

    public double gibZ(){
        return quader.gibZ();
    }
}
